$set noverify
$! FilSav.com
$! Copyright (c) 1994 Glenn C. Everhart. All Rights Reserved.
$! Input:
$! @filsav dev:file.typ hexfid1 hexfid2
$! We shall presume the "file.typ" is actually a complete file spec
$! here. It is passed to filrst too, so we need only pick a unique
$! save name that can be restored & copy to delsav. Use backup to
$! do the copy so attrs & ownership can be preserved.
$! In this version, rather than using one save area, we presume delsav
$! to be a list of areas and save in the first such with enough room
$! to hold the file. Also record where the file is so the restore
$! script can get it. Do so via a simple image that will save the data
$! separately.
$!
$! Script to save to staging area, then tape. Partly written.
$! Idea is to stage everything to disk first, then write a big
$! backup. Must record tape location when the backup is done.
$!
$ on warning then goto clnxit
$ file :==$gcy$sys:file
$ zip:==$gcy$sys:zip
$ unzip:==$gcy$sys:unzip
$! Implement a simple guard against two of these procedures running
$! at the same time so we won't need to worry about collisions. Just use
$! a lock file in gcy$sys for the purpose since that works cluster wide
$! and we want that to be so. These files are for shelving, so not
$! too likely to have multiples, but safety won't hurt.
$! invocation.
$! Create the lockfile if it doesn't exist yet.
$ if f$search("gcy$sys:fsvtap.lock;1") .eqs. ""
$ then
$ create gcy$sys:fsvtap.lock;1
 lockfile for disk->tape
$!
$ endif
$latchtest:
$ open/read/write/error=latchf gcy$sys:fsvtap.lock;1
$goto latchgot
$latchf:
$! If file couldn't be created just scram.
$ if f$search("gcy$sys:fsvtap.lock;1") .eqs. "" then exit 16
$! wait 30 seconds between looks at the logical
$ wait 0:0:30
$ goto latchtest
$latchgot:
$ infil=p1
$ inhx1=p2
$ inhx2=p3
$ spcmgn=5000 ! slop space allowed on save volume.
$ delsvr=delsav
$ needsz=f$file(infil,"ALQ")
$ dvc=f$parse(infil,,,"device","syntax_only")
$ dvc=f$edit(dvc,"collapse,upcase")
$! figure which store has the file.
$ ndvc=dvc - ":"
$ myelem = 0
$ firstdisk = " "
$ getdns:
$! For tape we want just two logicals for outswapping.
$! The first is for the disk staging area, and the second refers to a
$! tape drive to which we move everything when the disk fills up.
$ mynum=f$fao("!ZW",myelem)
$ mytst="GH"+ndvc+"GDX"+mynum
$ mystore = f$trnlnm(mytst)
$ if mystore .nes. ""
$ then
$ ! see if this device has room and if so goto gotdns
$! this is a FIRST FIT method.
$ if myelem .eq. 0 then firstdisk = mystore
$spcavl=f$getdvi(dvc,"FREEBLOCKS")
$! If this is the tape go handle it.
$ if myelem.eq.1 then goto gotdns
$if (spcavl .gt. (needsz+spcmgn)) then goto gotdns
$ endif
$ myelem = myelem + 1
$ if mystore .nes. "" then goto getdns
$! if we fall thru, can do nothing
$ close latchf
$ exit 4
$ gotdns:
$ savspc:==$gcy$sys:JTsavspc
$! let savspc image arg 1 say whether to add or delete a record
$ savspc A 'hexfid1''hexfid2' 'ndvc' 'mystore'
$ delsvr = mystore
$! Now delsvr is the correct save place and we just go ahead and pull the file
$! out.
$ fnam=f$parse(infil,,,"name","syntax_only")+f$parse(infil,,,"type","syntax_only")
$ fnam=f$edit(fnam,"collapse,upcase")
$ if f$locate(".DIR;1",fnam) .lt. f$length(fnam) then exit 4
$ if f$length(fnam) .gt. 20 then fnam=f$extract(0,20,fnam)
$ ofilnm="delsvr:"+inhx1+inhx2+fnam
$ ofzip=inhx1+inhx2+fnam-"."-";"
$ ofzip=f$extract(0,38,fnam)
$ ofzip=f$edit(ofilnm,"collapse,upcase")
$ ofilnm=f$edit(ofilnm,"collapse,upcase")
$ ! move the file
$ backup/trunc/ign=inter 'infil' 'ofilnm'/by_owner
$! If the user wants to store files compressed, let Zip compress them
$! at the save site.
$ curdef=f$environment("default")
$ if f$trnlnm("GCY$ZIPHSC") .eqs. "YES")
$ then
$  set def delsvr:
$! Compress the file we moved to nearline. (Note that if nearline isn't
$! disk, we should compress & decompress in a scratch area. If backing
$! store is tape this would be so.)
$  ofzip=inhx1+inhx2+fnam-"."-";"
$  ofzip=f$extract(0,38,fnam)
$  ofzip=f$edit(ofilnm,"collapse,upcase")
$  zip "-9Vq" 'ofzip' 'ofilnm'
$  delete 'ofilnm'.
$  set def 'curdef'
$ endif
$ ! now truncate the original
$ osiz=f$file_attributes(infil,"eof")
$ file/end=1/first_free=0 'infil'
$ set file/trunc/nobackup 'infil'
$ file/end='osiz'/first_free=510 'infil'
$! Above leaves original file truncated but leaves EOF mark at the original
$! location.
$ close latchf
$ logo
$clnexit:
$ close latchf
$ exit 8
